﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.51
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Public Version As String = "1.0.0.0"
	Public AppName As String = "Print to A4 and Letter"
End Sub

'Get the correct printer name
Private Sub GetPrinter(PrinterName As String) As Printer
	Dim Printers As List = Printer_Static.GetAllPrinters
	For Each P As Printer In Printers
		If P.GetName.StartsWith(PrinterName) Then Return P
	Next
	Return Null
End Sub

'Lost all printers on the computer
Sub ListAllPrinters() As List
	Dim PrList As List = Printer_Static.GetAllPrinters
	Dim PrNames As List
		PrNames.Initialize
	
	For Each Pr As Printer In PrList
		PrNames.Add(Pr.GetName)
	Next
	Return PrNames
End Sub

'Print the document 
'Has to be resumable sub for safe continuous printing of multiple documents at once

'Example on how to use:
'SharedCode.Print(MainForm, False, "Bullzip PDF Printer", True)
'(Main Form, Show printer dialog, Select the printer name, Set for A4 paper or Letter paper size)
Sub Print(MainForm As Form, ShowPrinterDialog As Boolean, PrinterName As String, UsingA4Paper As Boolean) As ResumableSub
	If ShowPrinterDialog Then 'Print with dialogs
		Dim PJ As PrinterJob = PrinterJob_Static.CreatePrinterJob 'CreatePrinterJob
			PJ.ShowPageSetupDialog(Null)
			PJ.ShowPrintDialog(Null)
			PJ.PrintPage(MainForm.RootPane)
			PJ.EndJob
	Else 'Setup printer and print without dialogs
		Dim PA As Paper
			PA.Initialize()

		If UsingA4Paper Then PA = Paper_static.A4 Else PA = Paper_static.NA_LETTER
		
'		Dim PR As Printer
'		PR.Initialize()
'		PR = Printer_Static.GetDefaultPrinter

		Dim PR As Printer = GetPrinter(PrinterName)
		
		Dim PL As PageLayout
			PL.Initialize()
			PL = PR.CreatePageLayout2(PA, PageOrientation_Static.PORTRAIT, "HARDWARE_MINIMUM")
		
		Dim PJ As PrinterJob = PrinterJob_Static.CreatePrinterJob2(PR) 'CreatePrinterJob
			PJ.PrintPage2(PL, MainForm.RootPane)
			PJ.EndJob
		MainForm.Close
	End If
	Return Null
End Sub
